# -*- coding: utf-8 -*-

#
# We need a new path query type, which is multilevel_navtree, returning a or
# between both.
# So let's monkey patch !
#

from Products.CMFPlone.CatalogTool import CatalogTool

old_serch = CatalogTool.searchResults


def searchResults(self, REQUEST=None, **kw):
    """
    Modified version of searchResults to handle multilevel_navtree
    """
    
    if "path" in kw:
        path = kw["path"]
    elif REQUEST and "path" in REQUEST:
        path = REQUEST["path"]
    else:
        path = None

    if hasattr(path, "has_key") and path.has_key("multilevel_navtree"):
        node = path['query']
        multilevel = path["multilevel_navtree"] - 1
        path["navtree"] = path["multilevel_navtree"]
        del path["multilevel_navtree"]
    else:
        multilevel = 0

    results = old_serch(self, REQUEST, **kw)

    # Now handle multilevel
    if multilevel > 0:
        final = list(results)
        
        for res in results:
            path = res.getPath()
            
            if path.startswith(node):
                continue
            kw["path"] = { 'query': path,
                           'depth': multilevel }
            additional = self.searchResults(REQUEST, **kw)
            final.extend(additional)

        done = set()
        results = []
        for res in final:
            path = res.getPath()
            if not path in done:
                done.add(path)
                results.append(res)

    return results

CatalogTool.searchResults = searchResults
